#!/usr/bin/perl

use constant EL_START => 0;
use constant EL_DESCRIPTOR => 1;
use constant EL_URL => 2;
use constant EL_ID => 3;
use constant EL_TARGET => 4;
use constant EL_END => 5;

use constant LINK_LINE_SUBTEST => ".push";

$WP_JSFILE_DIRECTORY = "/srv/www/novell/welcome-novell/config/";

if (@ARGV < 3 ) {
   die("\n Usage: wpupdatejs.pl filename.js ID new_url\n\n");
}

$arg_js_file_name = $ARGV[0];
$arg_id = $ARGV[1];
$arg_new_url = $ARGV[2];

$js_file_name = $WP_JSFILE_DIRECTORY . $arg_js_file_name;
$search_id = "\"" . $arg_id . "\"";


print("Using: $js_file_name\n");


# Read in the original includes file. Need to do this to see what
# javascript files are currently included.
open(MYFILE, $js_file_name ) || die ("Could not open the file\n");
@file_lines = <MYFILE>;

# Search through all of the lines;

foreach $line (@file_lines) {
   
   if ( index($line, LINK_LINE_SUBTEST) > 0) {
     # print("link: $line\n");

      # See if the link text exsits.
      if ( index($line, $search_id) > 0) {

         @line_array = split(/, /, $line);

         if ($line_array[EL_ID] eq $search_id) {
            $line_array[EL_URL] = "\"" . $arg_new_url . "\"";

            # Now put the modified array elements back into the original line.
            $line = $line_array[EL_START] . ", " .
            $line_array[EL_DESCRIPTOR] . ", " .
            $line_array[EL_URL] . ", " .
            $line_array[EL_ID] . ", " .
            $line_array[EL_TARGET] . ", " .
            $line_array[EL_END];
           
           # print("\nThe new line is now: $line\n");
         }

      }

   }
}

# The array is now ready to be saved back to the file.

# $js_file_name is the name of the original file.
$js_file_name_tmp = $js_file_name . ".tmp";
$js_file_name_bck = $js_file_name . ".bck";


open(OUTFILE, ">$js_file_name_tmp" ) || die ("Could not open file for output\n");

foreach $output_line (@file_lines) {
       print OUTFILE ("$output_line");
}
close(OUTFILE);

# The file is saved with a .tmp extension.
# The original file is renamed with a .bck extension.
# The .tmp file is renamed to the original file name.


# Delete the backup file, if it exists.
if ( -e $js_file_name_bck ) {
  unlink($js_file_name_bck);
}

# Now move the original file to be the backup file.
if ( -e $js_file_name ) {
   rename($js_file_name, $js_file_name_bck);
}

# Now move the temp file to be the real file.
return rename($js_file_name_tmp, $js_file_name);


