#!/usr/bin/perl


$imonitor_url = get_imonitor_url();
update_js_url_for_id("imonitor.js", IMONITORCLEAR, $imonitor_url);

# done



#
# Subroutines.
# 


sub get_imonitor_url() { 

   $nds_conf_file_name="/etc/opt/novell/eDirectory/conf/nds.conf";
   $nds_clear_port_key="http.server.clear-port";
   $nds_port_number="";
   $nds_new_url="";
   
   open(NDS_CONFIG_FILE, $nds_conf_file_name ) || die ("Could not open the file\n");
   @file_lines = <NDS_CONFIG_FILE>;
   
   # Search through all of the lines;
   
   foreach $line (@file_lines) {
   
      # What about empty lines?
   
      if ( index($line, "=") > 0) {
   
         @line_array = split(/=/, $line);
   
         if ($line_array[0] eq $nds_clear_port_key) {
            $nds_port_number=$line_array[1];
            chomp($nds_port_number);
	
            break;
         }
      }
   }

   $nds_new_url="http://%*reqservername%:" . $nds_port_number ."/nds";

   return $nds_new_url;

}





sub update_js_url_for_id {

   local($arg_js_file_name, $arg_id, $arg_new_url);
   $arg_js_file_name = $_[0];
   $arg_id = $_[1];
   $arg_new_url = $_[2];


   $WP_JSFILE_DIRECTORY = "/srv/www/novell/welcome-novell/links/";

   # EL starts for element.  These stand for element positions in an array.
   $EL_START = 0;
   $EL_DESCRIPTOR = 1;
   $EL_URL = 2;
   $EL_ID = 3;
   $EL_TARGET = 4;
   $EL_END = 5;
   
   $LINK_LINE_SUBTEST = ".push";

   $js_file_name = $WP_JSFILE_DIRECTORY . $arg_js_file_name;
   $search_id = "\"" . $arg_id . "\"";
   
   # Read in the entire JavaScript file.
   open(JS_FILE, $js_file_name ) || die ("Could not open the file\n");
   @file_lines = <JS_FILE>;
   
   # Search through all of the lines for lines containing the specified ID.;
   


   foreach $line (@file_lines) {
	
      if ( index($line, $LINK_LINE_SUBTEST) > 0) {
   
         # See if the link text exsits.
         if ( index($line, $search_id) > 0) {

            @line_array = split(/, /, $line);
   
            if ($line_array[$EL_ID] eq $search_id) {
               $line_array[$EL_URL] = "\"" . $arg_new_url . "\"";
   
               # Now put the modified array elements back into the original line.
               $line = $line_array[$EL_START] . ", " .
               $line_array[$EL_DESCRIPTOR] . ", " .
               $line_array[$EL_URL] . ", " .
               $line_array[$EL_ID] . ", " .
               $line_array[$EL_TARGET] . ", " .
               $line_array[$EL_END];
            }
         }
      }
   }
   
   # The array is now ready to be saved back to the file.
   
   # $js_file_name is the name of the original file.
   $js_file_name_tmp = $js_file_name . ".tmp";
   $js_file_name_bck = $js_file_name . ".bck";
   
   
   open(JS_OUTFILE, ">$js_file_name_tmp" ) || die ("Could not open file for output\n");
   
   foreach $output_line (@file_lines) {
          print JS_OUTFILE ("$output_line");
   }
   close(JS_OUTFILE);
   
   # The file is saved with a .tmp extension.
   # The original file is renamed with a .bck extension.
   # The .tmp file is renamed to the original file name.
   
   
   # Delete the backup file, if it exists.
   if ( -e $js_file_name_bck ) {
     unlink($js_file_name_bck);
   }
   
   # Now move the original file to be the backup file.
   if ( -e $js_file_name ) {
      rename($js_file_name, $js_file_name_bck);
   }


   # Now move the temp file to be the real file.
   return rename($js_file_name_tmp, $js_file_name);



}







